
USE [tempdb];
GO

SELECT
	dtl.request_mode,
	CASE 
		WHEN dtl.resource_type = 'OBJECT' THEN OBJECT_NAME(dtl.resource_associated_entity_id)
		ELSE OBJECT_NAME(p.[object_id])
	END										AS [Object],
	dtl.resource_type,
	COUNT_BIG(*)							AS [Total Locks]
FROM
	sys.dm_tran_locks AS dtl
	LEFT JOIN sys.partitions AS p ON dtl.resource_associated_entity_id = p.hobt_id
WHERE
	dtl.resource_type <> 'DATABASE'
GROUP BY
	CASE 
		WHEN dtl.resource_type = 'OBJECT' THEN OBJECT_NAME(dtl.resource_associated_entity_id)
		ELSE OBJECT_NAME(p.[object_id])
	END,
	dtl.resource_type,
	dtl.request_mode
OPTION (RECOMPILE, MAXDOP 1)


--	Find object name by page Id

DECLARE
	@wait_resource		NVARCHAR(128) = N'2:1:344',
	@DBname				SYSNAME
	
	SET @DBname			= QUOTENAME(DB_NAME(LEFT(@wait_resource, (CHARINDEX(N':', @wait_resource)-1))))
	SET @wait_resource	= REPLACE(@wait_resource, N':', N',')

	EXECUTE ( N'DROP TABLE IF EXISTS #DBCCoutput
	CREATE TABLE #DBCCoutput
								(
									ParentObject	NVARCHAR(128),
									[Object]		NVARCHAR(128),
									Field			NVARCHAR(128),
									VALUE			NVARCHAR(128)
								)
	INSERT INTO #DBCCoutput
	EXECUTE (''DBCC PAGE (' + @wait_resource + N') WITH TABLERESULTS;'')
	
	USE ' + @DBname + N'

	SELECT
		DB_NAME() + N''.'' + sc.name + N''.'' + so.name + N''.'' + si.name as Name
	FROM
		sys.objects so
		JOIN sys.indexes si ON so.object_id = si.object_id
		JOIN sys.schemas sc ON so.schema_id = sc.schema_id
	WHERE
		so.object_id = (SELECT VALUE FROM #DBCCoutput WHERE Field = N''Metadata: ObjectId'')
		and si.index_id = (SELECT VALUE FROM #DBCCoutput WHERE Field = N''Metadata: IndexId'');');


--DBCC PAGE (2,1,1) WITH TABLERESULTS
