
-- Check IO usage + copy to notepad
SET STATISTICS IO ON

SELECT *
FROM
	tempdb.sys.all_objects;
GO

SELECT *
FROM
	tempdb.sys.tables;
GO

SET STATISTICS IO OFF


-- Change server configuration
ALTER SERVER CONFIGURATION SET MEMORY_OPTIMIZED TEMPDB_METADATA = ON | OFF;
GO


-- Reboot SQL Server service


-- Check server configuration
SELECT *
FROM
	sys.configurations
WHERE
	[name] LIKE '%TEMPDB%';
GO



-- Check IO usage again + compare with notepad
SET STATISTICS IO ON

SELECT *
FROM
	tempdb.sys.all_objects;
GO

SELECT *
FROM
	tempdb.sys.tables;
GO

SET STATISTICS IO OFF



-- In-memory tables
USE [tempdb];
GO

SELECT
	OBJECT_NAME([object_id])	AS [TableName],
	*
FROM
	tempdb.sys.dm_db_xtp_object_stats;
GO
